//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DIGMdlls.h"    // prototypes of all routines in a DIGIMODE - DLL.


#include "TestHost.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

// Definition of procedure-pointer-types for all required routines in the
// 'user-loadable DLL'
typedef  char* __import _stdcall(GET_PARAM_STRING)(long param_nr);


/********** Implementation of a small 'test application' for the DLL *******/
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void __fastcall TForm1::Btn_LoadClick(TObject *Sender)
{
 HMODULE dll_handle;
 GET_PARAM_STRING *pGetParamString;
 DWORD error_code;
 LPVOID lpMsgBuf; AnsiString s;  // for GetLastError()
 int   i;


   // First try to load the required library
   if ( (dll_handle = LoadLibrary( Ed_DLLname->Text.c_str() )) !=NULL)
    {
      // arrived here: Library exists and could be loaded.
      // Get the entry addresses of all required procedures.
      // GetProcAddress returns a NULL pointer if a routine is missing.
      pGetParamString=(GET_PARAM_STRING *) GetProcAddress( dll_handle,"_DIGM_GetParamString");
      if(pGetParamString==NULL)   // try again without the underscore prefix:
        pGetParamString=(GET_PARAM_STRING *) GetProcAddress( dll_handle,"DIGM_GetParamString");
      if(pGetParamString==NULL)   // try again with PASCAL notation:
        pGetParamString=(GET_PARAM_STRING *) GetProcAddress( dll_handle,"digm_getparamstring");
      if(pGetParamString==NULL)
       {   // Something seems to be wrong with this DLL
        error_code = GetLastError();  // ..from GetProcAddress()
        // Convert the GetLastError()-code into a readable string:
        FormatMessage(
             FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
             NULL,
             error_code,        // .. from GetLastError()
             MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
             // (dont expect to see other languages if you replace "LANG_NEUTRAL" !)
            (LPTSTR) &lpMsgBuf,
             0,
             NULL );
        // Convert the string and free the message's buffer.
        s = "GetProcAddress: " + AnsiString( (char*) lpMsgBuf );
        // Free the buffer.
        LocalFree( lpMsgBuf );

        ShowMessage("Couldn't find address of \"GetParamString\" in the DLL.\r\n"+s);
       }



      // More info about GetProcAddress() from the help system:
      // > The spelling and case of the function name pointed to by lpProcName
      // > must be identical to that in the EXPORTS statement
      // > of the source DLL's module-definition (.DEF) file.
      if (pGetParamString != NULL)
       {// Address of the routine "DIGM_GetParamString()" in the loaded DLL
        // is known now. Read the first parameter strings from the DLL.
        for(i=0;i<=2;++i)
           Memo_Messages->Lines->Append( (*pGetParamString) (i) );
       }
     FreeLibrary( dll_handle );
    } // end if <LoadLibrary successful>
   else
    {
      ShowMessage("Couldn't load DLL.");
    }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Btn_EraseMsgClick(TObject *Sender)
{
  Memo_Messages->Lines->Clear();
}
//---------------------------------------------------------------------------

